﻿Type=Class
Version=4.3
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private nativeMe As JavaObject
	
End Sub
'Initializes the object.
Public Sub Initialize
	nativeMe = Me
'	nativeMe.InitializeContext
End Sub

Public Sub getConnectivityStatus() As Int

Dim connectStatus As Int = 0
connectStatus = nativeMe.RunMethod("getConnectivityStatus",Array(connectStatus))
Return connectStatus

End Sub
Public Sub getConnectivityStatusString() As String

Dim connectStatus As String
Dim dummy As Int = 0
connectStatus = nativeMe.RunMethod("getConnectivityStatusString",Array(dummy))
Return connectStatus

End Sub
Public Sub isOnline() As Boolean

Dim lineStatus As Boolean
Dim dummy As Int = 0
lineStatus = nativeMe.RunMethod("isOnline",Array(dummy))
Return lineStatus

End Sub

Public Sub checkWifiMobileStatus() As String

Dim lineStatus As String
Dim dummy As Int = 0
lineStatus = nativeMe.RunMethod("checkWifiMobileStatus",Array(dummy))
Return lineStatus

End Sub
Public Sub getWifiName() As String

Dim lineStatus As String
Dim dummy As Int = 0
lineStatus = nativeMe.RunMethod("getWifiName",Array(dummy))
Return lineStatus

End Sub
Public Sub getMobileNetworkName() As String

Dim lineStatus As String
Dim dummy As Int = 0
lineStatus = nativeMe.RunMethod("getMobileNetworkName",Array(dummy))
Return lineStatus

End Sub
Public Sub getGateway() As String

Dim lineStatus As String
Dim dummy As Int = 0
lineStatus = nativeMe.RunMethod("getGateway",Array(dummy))
Return lineStatus

End Sub
'Return the type of network that the device is connected to.
Public Sub getNetworkClass() As String

Dim nwClass As String
Dim dummy As Int = 0
nwClass = nativeMe.RunMethod("getNetworkClass",Array(dummy))
Return nwClass

End Sub
Public Sub isNetworkAvailable() As Boolean

Dim lineStatus As Boolean
Dim dummy As Int = 0
lineStatus = nativeMe.RunMethod("isNetworkAvailable",Array(dummy))
Return lineStatus

End Sub




#If Java

import android.content.Context;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import java.lang.Runtime;
import android.os.Bundle;
import java.io.*;
import java.lang.Process;
import android.net.wifi.WifiManager;
import android.telephony.TelephonyManager;

    Context context;
    public static int TYPE_WIFI = 1;
    public static int TYPE_MOBILE = 2;
    public static int TYPE_NOT_CONNECTED = 0;
	
    public static int getConnectivityStatus(int dummy) {
        ConnectivityManager cm = (ConnectivityManager) BA.applicationContext.getSystemService(Context.CONNECTIVITY_SERVICE);
 
        NetworkInfo activeNetwork = cm.getActiveNetworkInfo();
        if (null != activeNetwork) {
            if(activeNetwork.getType() == ConnectivityManager.TYPE_WIFI)
                return TYPE_WIFI;
             
            if(activeNetwork.getType() == ConnectivityManager.TYPE_MOBILE)
                return TYPE_MOBILE;
        } 
        return TYPE_NOT_CONNECTED;
    }
     
    public static String getConnectivityStatusString(int dummy) {
        int conn = getConnectivityStatus(dummy);
        String status = null;
        if (conn == TYPE_WIFI) {
            status = "Wifi enabled";
        } else if (conn == TYPE_MOBILE) {
            status = "Mobile data enabled";
        } else if (conn == TYPE_NOT_CONNECTED) {
            status = "Not connected to Internet";
        }
        return status;
    }


//  The ping utility exits with one of the following values: 
//  (0) At least one response was heard from the specified host. 
//  (2) The transmission was successful but no responses were received. 
//  (any other value) An error occurred. 
//  These values are defined in <sysexits.h>. ... in short it means that the ping worked, but the server did not respond, or in other words: no internet connection 
//  This is great peace of code! I found it very useful on devices that use prepaid cards! When they run out of money, they have internet access available, but no internet. So just checking for connectivity would not do. 
	public boolean isOnline(int dummy) {

	    Runtime runtime = Runtime.getRuntime();
	    try {

	        Process ipProcess = runtime.exec("/system/bin/ping -c 1 8.8.8.8");
	        int     exitValue = ipProcess.waitFor();
	        return (exitValue == 0);

	    } catch (IOException e)          { e.printStackTrace(); } 
	      catch (InterruptedException e) { e.printStackTrace(); }

	    return false;
	}

		
	
	public String checkWifiMobileStatus (int dummy) {	
	    ConnectivityManager connManager = (ConnectivityManager) BA.applicationContext.getSystemService(Context.CONNECTIVITY_SERVICE);
	    NetworkInfo mWifi = connManager.getNetworkInfo(ConnectivityManager.TYPE_WIFI);
	    NetworkInfo mMobile = connManager.getNetworkInfo(ConnectivityManager.TYPE_MOBILE);

	    if (mWifi.isAvailable() == true) {
	        return "Connected to WiFi";
	    } else if (mMobile.isAvailable() == true) {
	        return "Connected to Mobile Network";
	    } else return "No internet Connection";		
    }
	
	
	public static String getWifiName (int dummy) {
		WifiManager wifiManager = (WifiManager) BA.applicationContext.getSystemService(Context.WIFI_SERVICE);
		String wifiName = wifiManager.getConnectionInfo().getSSID();
		if (wifiName != null){
			if (!wifiName.contains("unknown ssid") && wifiName.length() > 2){
				if (wifiName.startsWith("\"") && wifiName.endsWith("\""))
					wifiName = wifiName.subSequence(1, wifiName.length() - 1).toString();
				return wifiName;
			} else {
				return "";
			}
		} else {
			return "";
		}
	}

    public static String getMobileNetworkName (int dummy) {
        TelephonyManager tm = (TelephonyManager)BA.applicationContext.getSystemService(Context.TELEPHONY_SERVICE);
        String networkName = tm.getNetworkOperatorName();
        if (networkName != null) {
            return networkName;
        }
        return "";
    }
	
	public static String getGateway (int dummy) {
		WifiManager wm = (WifiManager) BA.applicationContext.getSystemService(Context.WIFI_SERVICE);
		return intToIp(wm.getDhcpInfo().gateway);
	}
	
	public static String intToIp(int i) {
		return ((i >> 24 ) & 0xFF ) + "." +
				((i >> 16 ) & 0xFF) + "." +
				((i >> 8 ) & 0xFF) + "." +
				( i & 0xFF) ;
	}	
	
	public static String getNetworkClass(int dummy) {
	    ConnectivityManager cm = (ConnectivityManager) BA.applicationContext.getSystemService(Context.CONNECTIVITY_SERVICE);      
	    NetworkInfo info = cm.getActiveNetworkInfo();
	    if(info==null || !info.isConnected())
	        return "-"; //not connected
	    if(info.getType() == ConnectivityManager.TYPE_WIFI)
	        return "WIFI";
	    if(info.getType() == ConnectivityManager.TYPE_MOBILE){
	        int networkType = info.getSubtype();
	        switch (networkType) {
	            case TelephonyManager.NETWORK_TYPE_GPRS:
	            case TelephonyManager.NETWORK_TYPE_EDGE:
	            case TelephonyManager.NETWORK_TYPE_CDMA:
	            case TelephonyManager.NETWORK_TYPE_1xRTT:
	            case TelephonyManager.NETWORK_TYPE_IDEN: //api<8 : replace by 11
	                return "2G";
	            case TelephonyManager.NETWORK_TYPE_UMTS:
	            case TelephonyManager.NETWORK_TYPE_EVDO_0:
	            case TelephonyManager.NETWORK_TYPE_EVDO_A:
	            case TelephonyManager.NETWORK_TYPE_HSDPA:
	            case TelephonyManager.NETWORK_TYPE_HSUPA:
	            case TelephonyManager.NETWORK_TYPE_HSPA:
	            case TelephonyManager.NETWORK_TYPE_EVDO_B: //api<9 : replace by 14
	            case TelephonyManager.NETWORK_TYPE_EHRPD:  //api<11 : replace by 12
	            case TelephonyManager.NETWORK_TYPE_HSPAP:  //api<13 : replace by 15
	                return "3G";
	            case TelephonyManager.NETWORK_TYPE_LTE:    //api<11 : replace by 13
	                return "4G";
	            default:
	                return "?";
	         }
	    }
	    return "?";
	}

	public static boolean isNetworkAvailable(int dummy) {
	     ConnectivityManager connectivity = (ConnectivityManager) BA.applicationContext.getSystemService(Context.CONNECTIVITY_SERVICE);
	     if (connectivity != null) {
	        NetworkInfo[] info = connectivity.getAllNetworkInfo();
	        if (info != null) {
	           for (int i = 0; i < info.length; i++) {
	              if (info[i].getState() == NetworkInfo.State.CONNECTED) {
	                 return true;
	              }
	           }
	        }
	     }
	     return false;
	}

	

#End If